c---------------------------------------------------------------------
c      subroutine read_para(nequa,nstep,x1_read,x2_read,value_read,
      subroutine readpa
      implicit real*8(a-h,o-z)
c      implicit none
c variable only to input initial parameters
      character*80 a,filenames,filenamec,filenamew,filenamep,filenamek,
     >     filenameg
      real*8 value
      include 'inclm.h'
c      include 'mass.h'
      include 'inclc.h'
c      include 'coup.h'
c      include 'kine.h'
      integer unl
      parameter (unl=10)
      integer npart
      parameter (npart=43)

c     read this from configuration file
      filenames='out.spc'
      filenamec='out.cpl'
      filenamew='out.wid'
      filenamep='out.par'
      filenamek='in.kin'
      filenameg='in.gau'

c     mass spectrum
      open(unit=unl,file=filenames,status='old')
        do i=1,npart
           read(unl,*) a,value,kf
           if (a.eq.'Z           ') amz      =value
           if (a.eq.'W           ') amw      =value
           if (a.eq.'electron    ') amlp(1)  =value
           if (a.eq.'muon        ') amlp(2)  =value
           if (a.eq.'tau         ') amlp(3)  =value
           if (a.eq.'d           ') amdq(1)  =value
           if (a.eq.'u           ') amuq(1)  =value
           if (a.eq.'s           ') amdq(2)  =value
           if (a.eq.'c           ') amuq(2)  =value
           if (a.eq.'b           ') amdq(3)  =value
           if (a.eq.'t           ') amuq(3)  =value
           if (a.eq.'chargino1   ') amsw(1)  =value
           if (a.eq.'chargino2   ') amsw(2)  =value
           if (a.eq.'neutralino1 ') amnl(1)  =value
           if (a.eq.'neutralino2 ') amnl(2)  =value
           if (a.eq.'neutralino3 ') amnl(3)  =value
           if (a.eq.'neutralino4 ') amnl(4)  =value
           if (a.eq.'gluino      ') amgl     =value
           if (a.eq.'selectron1  ') amsl(1,1)=value
           if (a.eq.'selectron2  ') amsl(1,2)=value
           if (a.eq.'snu-e       ') amsn(1)  =value
           if (a.eq.'smuon1      ') amsl(2,1)=value
           if (a.eq.'smuon2      ') amsl(2,2)=value
           if (a.eq.'snu-mu      ') amsn(2)  =value
           if (a.eq.'stau1       ') amsl(3,1)=value
           if (a.eq.'stau2       ') amsl(3,2)=value
           if (a.eq.'snu-tau     ') amsn(3)  =value
           if (a.eq.'sd1         ') amsd(1,1)=value
           if (a.eq.'sd2         ') amsd(1,2)=value
           if (a.eq.'su1         ') amsu(1,1)=value
           if (a.eq.'su2         ') amsu(1,2)=value
           if (a.eq.'ss1         ') amsd(2,1)=value
           if (a.eq.'ss2         ') amsd(2,2)=value
           if (a.eq.'sc1         ') amsu(2,1)=value
           if (a.eq.'sc2         ') amsu(2,2)=value
           if (a.eq.'sb1         ') amsd(3,1)=value
           if (a.eq.'sb2         ') amsd(3,2)=value
           if (a.eq.'st1         ') amsu(3,1)=value
           if (a.eq.'st2         ') amsu(3,2)=value
           if (a.eq.'Higgs1      ') amh1     =value
           if (a.eq.'Higgs2      ') amh2     =value
           if (a.eq.'Higgs3      ') amh3     =value
           if (a.eq.'Higgs+      ') amhc     =value
        enddo
      close(unit=unl)

c     coupling
      open(unit=unl,file=filenamec,status='old')
      read(unl,*)         cqed,     cqcd,     czww,     caww,     cggg,
     >                    chww,     chzz,    chhwp,    chhwm,   chhz13,
     >                  chhz23,   chhzpm,   chhapm,   chhh01,   chhh02,
     >                  chhh03,   chhh04,   chhh05,   chhh06,   chhhc1,
     >                  chhhc2,     cwzm,     cwam,     cwzp,     cwap,
     >                  chhx13,   chhx23,    chhxm,    chhxp,    chxwp,
     >                   chxwm,     chxz,     cwym,     cwyp,     czpm,
     >                    capm,     chpm,     chyy,     cwln,     cwnl,
     >                    cwdu,     cwud,     call,     cauu,     cadd,
     >                    cznn,     czll,     czuu,     czdd,     cguu,
     >                    cgdd,     chll,    chllp,    chllm,     chdd,
     >                    chuu,    chudp,    chudm,     cmln,     cpnl,
     >                    cmdu,     cpud,     cyll,     cyuu,     cydd,
     >                    cdda,     cddz,     cddh,     cddx,     cmmz,
     >                    cmmh,     cmmx,    cdmwp,    cdmwm,    cdmhp,
     >                   cdmhm,    cdmxp,    cdmxm,    cssla,    cssda
      read(unl,*)        cssua,    cssnz,    csslz,    cssdz,    cssuz,
     >                  csslwm,   csslwp,   cssqwm,   cssqwp,    cssdg,
     >                   cssug,   chslnn,   chsllp,   chslnu,   chslun,
     >                  chsqdq,   chsquq,   chsqim,   chsqip,   csly12,
     >                  csly21,    cslxm,    cslxp,   csdy12,   csdy21,
     >                  csuy12,   csuy21,    csqxm,    csqxp,   csfdel,
     >                  csfdle,   csfdnu,   csfdun,   csfddq,   csfdqd,
     >                  csfduq,   csfdqu,   csfmnu,   csfmun,   csfmel,
     >                  csfmle,   csfmdq,   csfmqd,   csfmuq,   csfmqu,
     >                   cwczp,    cwcmz,    cwcap,    cwcma,    cwczm,
     >                   cwcpz,    cwcam,    cwcpa,    czcmm,    czcpp,
     >                   cacmm,    cacpp,    cgcgg,   chccm1,   chccp1,
     >                  chccz1,   chccm2,   chccp2,   chccz2,    cpczp,
     >                   cpcap,    cpcmz,    cmczm,    cmcam,    cmcpz,
     >                   cycmm,    cycpp,   cgogog,   csfgdq,   csfgqd,
     >                  csfguq,   csfgqu,    cwwaa,    cwwza,    cwwzz
      read(unl,*)        cwwww,    cgggg,    chhww,    chhzz,    chhza,
     >                   chhaa,   chhwzm,   chhwzp,   chhwam,   chhwap,
     >                  ch1111,   ch1112,   ch1122,   ch1222,   ch2222,
     >                  ch3333,   ch1133,   ch1233,   ch2233,    ch4pm,
     >                  ch4pm2,    cwwyy,    czzyy,    cwzym,    cwzyp,
     >                   cwaym,    cwayp,    cwwpm,    czzpm,    caapm,
     >                   czapm,    cwzhm,    cwzhp,    cwahm,    cwahp,
     >                   chhhx,   chhhxm,   chhhxp,    chhyy,   chhcyy,
     >                  chhxpy,   chhxmy,   chhxpm,   chhcpm,   chhpxm,
     >                  chhmxp,   ch3yyy,   chpyym,   chmyyp,   ch3ypm,
     >                  chpmpm,   chmppm,    cyyyy,    cpmyy,    cpmpm,
     >                  csswwn,   csswwl,   csswwd,   csswwu,   cslwzp,
     >                  cslwzm,   csqwzp,   csqwzm,   cslwap,   cslwam,
     >                  csqwap,   csqwam,   csszzl,   csszzn,   csszzu,
     >                  csszzd,   csszal,   csszau,   csszad,   cssaal,
     >                  cssaau,   cssaad,   csh2nu,   csh2lp,   csh2uq
      read(unl,*)       csh2dq,   csh2ln,   csh2nl,   csh2du,   csh2ud,
     >                  csh2cn,   csh2cl,   csh2cu,   csh2cd,   cshynu,
     >                  cshylp,   cshyuq,   cshydq,   cshyln,   cshynl,
     >                  cshydu,   cshyud,   cshxln,   cshxnl,   cshxdu,
     >                  cshxud,   cshnpm,   cshnmp,   cshlpm,   cshlmp,
     >                  cshupm,   cshump,   cshdpm,   cshdmp,   csy2nu,
     >                  csy2lp,   csy2uq,   csy2dq,   csxyln,   csxynl,
     >                  csxydu,   csxyud,   csxxnu,   csxxlp,   csxxuq,
     >                  csxxdq,   cs4snu,   cs4slp,   csnnll,   cs4ilp,
     >                  csnlln,   cslnnl,   cs4mnd,   cs4mnu,   cs4mld,
     >                  cs4mlu,   csnldu,   cslnud,   csdddd,   cqdddd,
     >                  csuuuu,   cquuuu,   csuudd,   cquudd,   csuddu,
     >                  cquddu,   csddss,   cqddss,   cqdssd,   csuucc,
     >                  cquucc,   cquccu,   csuuss,   cquuss,   cqussu,
     >                  csddcc,   cqddcc,   cqdccd,   csducs,   csudsc,
     >                  cssggu,   cssggd,   cssgwp,   cssgwm,   cssgzd
      read(unl,*,end=1)       cssgzu,   cssgad,   cssgau
      close(unit=unl)

c     decay width
      open(unit=unl,file=filenamew,status='old')
        do i=1,npart
           read(unl,*) a,value,kf
           if (a.eq.'Z           ') agz      =value
           if (a.eq.'W           ') agw      =value
c          if (a.eq.'electron    ') aglp(1)  =value
c          if (a.eq.'muon        ') aglp(2)  =value
c          if (a.eq.'tau         ') aglp(3)  =value
           if (a.eq.'d           ') agdq(1)  =value
           if (a.eq.'u           ') aguq(1)  =value
           if (a.eq.'s           ') agdq(2)  =value
           if (a.eq.'c           ') aguq(2)  =value
           if (a.eq.'b           ') agdq(3)  =value
           if (a.eq.'t           ') aguq(3)  =value
           if (a.eq.'chargino1   ') agsw(1)  =value
           if (a.eq.'chargino2   ') agsw(2)  =value
           if (a.eq.'neutralino1 ') agnl(1)  =value
           if (a.eq.'neutralino2 ') agnl(2)  =value
           if (a.eq.'neutralino3 ') agnl(3)  =value
           if (a.eq.'neutralino4 ') agnl(4)  =value
           if (a.eq.'gluino      ') aggl     =value
           if (a.eq.'selectron1  ') agsl(1,1)=value
           if (a.eq.'selectron2  ') agsl(1,2)=value
           if (a.eq.'snu-e       ') agsn(1)  =value
           if (a.eq.'smuon1      ') agsl(2,1)=value
           if (a.eq.'smuon2      ') agsl(2,2)=value
           if (a.eq.'snu-mu      ') agsn(2)  =value
           if (a.eq.'stau1       ') agsl(3,1)=value
           if (a.eq.'stau2       ') agsl(3,2)=value
           if (a.eq.'snu-tau     ') agsn(3)  =value
           if (a.eq.'sd1         ') agsd(1,1)=value
           if (a.eq.'sd2         ') agsd(1,2)=value
           if (a.eq.'su1         ') agsu(1,1)=value
           if (a.eq.'su2         ') agsu(1,2)=value
           if (a.eq.'ss1         ') agsd(2,1)=value
           if (a.eq.'ss2         ') agsd(2,2)=value
           if (a.eq.'sc1         ') agsu(2,1)=value
           if (a.eq.'sc2         ') agsu(2,2)=value
           if (a.eq.'sb1         ') agsd(3,1)=value
           if (a.eq.'sb2         ') agsd(3,2)=value
           if (a.eq.'st1         ') agsu(3,1)=value
           if (a.eq.'st2         ') agsu(3,2)=value
           if (a.eq.'Higgs1      ') agh1     =value
           if (a.eq.'Higgs2      ') agh2     =value
           if (a.eq.'Higgs3      ') agh3     =value
           if (a.eq.'Higgs+      ') aghc     =value
        enddo
      close(unit=unl)

c     extra parameters
      if (.false.) then 
      open(unit=unl,file=filenamep,status='old')
c        read(unl,*) npara,a
c        do i=1,**********************************
           read(unl,*) value,a
           if (a.eq.'Scale \Lambda')  lambda=value
           if (a.eq.'Z^0 pole mass')  amz=value
           if (a.eq.'Fermi constant') GFermi=value
           if (a.eq.'1/a_em(M_Z)')    invalpha=value
           if (a.eq.'a_S')            alphas=value
           if (a.eq.'\tan\beta')      tanbe=value
           if (a.eq.'Mu')             xmu=value
           if (a.eq.'M1')             xm1=value
           if (a.eq.'M2')             xm2=value
           if (a.eq.'M3')             xm3=value
c     enddo
      close(unit=unl)
      endif

c     kinematics parameters : \sqrt{s}, cuts ?
      if (.false.) then 
      open(unit=unl,file=filenamek,status='old')
c        do i=1,**********************************
           read(unl,*) value,a
           if (a.eq.'')  W=value
c        enddo
      close(unit=unl)
      endif

c     gauge parameters : ?
      if (.false.) then 
      open(unit=unl,file=filenamek,status='old')
c        do i=1,**********************************
           read(unl,*) value,a
           if (a.eq.'')  xgauge=value
c        enddo
      close(unit=unl)
      endif

      return

 1    write(*,*) 'Caution : End of coupling file'
      write(*,*) cssgzu
      write(*,*) 
      write(*,*) cssgad
      write(*,*) 
      write(*,*) cssgau

      return
      end
c---------------------------------------------------------------------
