* FILE kfill
*
* Grace Version   1.00.00          MLIB.GRACE.V920425
************************************************************************
      SUBROUTINE KFILL(NEXTRN, ndim, X, PE, PP, ANS) 

      IMPLICIT REAL* 8(A-H,O-Z)

************************************************************************
      INTEGER NEXTRN 
      PARAMETER ( MXDIM = 50 )
      REAL*8  X(MXDIM) 
      REAL*8  PE(4,NEXTRN), PP(NEXTRN,NEXTRN) 

      INCLUDE 'inclk.h'
      common /sp4vec/ vec(4,8)
      real*8 pw(4),pm(4),pn(4)
*=======================================================================
*          Fill Histograms and Scatter plots
*=======================================================================
        anss=ans
        if(anss.lt.1.d-10)anss=0

           CALL XHFILL( 1,vec(4,3) , ANSs )
           CALL XHFILL( 2,vec(4,4) , ANSs )
           CALL XHFILL( 3,vec(4,5) , ANSs )
           CALL XHFILL( 4,vec(4,6) , ANSs )
           CALL XHFILL( 5,vec(4,7) , ANSs )
           CALL XHFILL( 6,vec(4,8) , ANSs )

	   cos3=vec(3,3)/sqrt(vec(1,3)**2+vec(2,3)**2+vec(3,3)**2)
           CALL XHFILL( 7,cos3, ANSs )
	   cos4=vec(3,4)/sqrt(vec(1,4)**2+vec(2,4)**2+vec(3,4)**2)
           CALL XHFILL( 8,cos4, ANSs )
	   cos5=vec(3,5)/sqrt(vec(1,5)**2+vec(2,5)**2+vec(3,5)**2)
           CALL XHFILL( 9,cos5, ANsS )
	   cos6=vec(3,6)/sqrt(vec(1,6)**2+vec(2,6)**2+vec(3,6)**2)
           CALL XHFILL(10,cos6, ANSs )
	   cos7=vec(3,7)/sqrt(vec(1,7)**2+vec(2,7)**2+vec(3,7)**2)
           CALL XHFILL(11,cos7, ANSs )
	   cos8=vec(3,8)/sqrt(vec(1,8)**2+vec(2,8)**2+vec(3,8)**2)
           CALL XHFILL(12,cos8, ANSs )

c          CALL XHFILL(13,sqrt(q45), ANSs )
c          CALL XHFILL(14,sqrt(q67), ANSs )
c          CALL XHFILL(15,sqrt(q12), ANSs )
c          CALL XHFILL(16,sqrt(q22), ANSs )
c          CALL XHFILL(17,sqrt(qall), ANSs )

           pt4=sqrt(vec(1,4)**2+vec(2,4)**2)
           pt5=sqrt(vec(1,5)**2+vec(2,5)**2)
           pt6=sqrt(vec(1,6)**2+vec(2,6)**2)
           CALL XHFILL(18,pt4,ANSs)
           CALL XHFILL(19,pt6,ANSs)
           CALL XHFILL(20,pt5,ANSs)
           pt3=sqrt(vec(1,3)**2+vec(2,3)**2)
           pt7=sqrt(vec(1,7)**2+vec(2,7)**2)
           pt8=sqrt(vec(1,8)**2+vec(2,8)**2)
           CALL XHFILL(21,pt3,ANSs)
           CALL XHFILL(21,pt7,ANSs)
           CALL XHFILL(21,pt8,ANSs)

           CALL XHFILL(22,pt3,ANSs)
           CALL XHFILL(23,pt7,ANSs)
           CALL XHFILL(24,pt8,ANSs)

           pw(1)= (vec(1,4)+vec(1,5))
           pw(2)= (vec(2,4)+vec(2,5))
           pw(3)= (vec(3,4)+vec(3,5))
           pw(4)= (vec(4,4)+vec(4,5))
           call labtow(vec(1,4),vec(1,5),pw, pm,pn)
           cosmu2=pm(3)
     ./sqrt(pm(1)**2+pm(2)**2+pm(3)**2)


           CALL XHFILL(25,cosmu2,ANSs)

           cossc=(vec(1,3)*vec(1,8)+vec(2,3)*vec(2,8)+vec(3,3)*vec(3,8))
     ./sqrt(vec(1,3)**2+vec(2,3)**2+vec(3,3)**2)
     ./sqrt(vec(1,8)**2+vec(2,8)**2+vec(3,8)**2)

           CALL XHFILL(26,cossc,ANSs)
      RETURN
      END
